/* $Id: adapter.c,v 1.10 2003/10/20 06:03:29 vizzini Exp $
 *
 * COPYRIGHT:       See COPYING in the top level directory
 * PROJECT:         ReactOS kernel
 * FILE:            ntoskrnl/io/adapter.c
 * PURPOSE:         DMA handling
 * PROGRAMMER:      David Welch (welch@mcmail.com)
 * UPDATE HISTORY:
 *                  Created 22/05/98
 */

/* INCLUDES *****************************************************************/

#include <ddk/ntddk.h>
#include <ddk/halfuncs.h>

#include <internal/debug.h>

/* DATA **********************************************************************/

POBJECT_TYPE EXPORTED IoAdapterObjectType = NULL;	/* FIXME */
POBJECT_TYPE EXPORTED IoDeviceHandlerObjectType = NULL;	/* FIXME */
ULONG        EXPORTED IoDeviceHandlerObjectSize = 0;    /* FIXME */

/* FUNCTIONS *****************************************************************/

/*
 * @implemented
 */
NTSTATUS STDCALL
IoAllocateAdapterChannel (PADAPTER_OBJECT	AdapterObject,
			  PDEVICE_OBJECT	DeviceObject,
			  ULONG		NumberOfMapRegisters,
			  PDRIVER_CONTROL	ExecutionRoutine,
			  PVOID		Context)
{
  DeviceObject->Queue.Wcb.DeviceObject = DeviceObject;
  DeviceObject->Queue.Wcb.DeviceContext = Context;

  return HalAllocateAdapterChannel( AdapterObject,
				    &DeviceObject->Queue.Wcb,
				    NumberOfMapRegisters,
				    ExecutionRoutine);
}


/* NOTE: Missing IoXXXAdapter finctions in HAL.DLL */


/* EOF */
